﻿package 
{
	/**
	* Advanced trace method
	*
	* @author Benoît Freslon
	* @version 1.0
	* @example 	Usage
	* <listing version="3.0">
	* import Debug;
	* Debug.trace("foo", "bar");
	* </listing>
	* output > [Class][Method][line] foo bar
	**/
	public class Debug
	{

		static public function log(...rest)
		{
			var error:Error = new Error();
			
			var tr:String = "";
			for each (var msg:String in rest)
			{
				tr +=  msg + " ";
			}
			var s:String = error.getStackTrace();
			
			var arr:Array = s.split("at ")[2].split("()");
			
			var stack:String = arr[0];
			var arrClass:Array = stack.split("/")[0].split("::");
			var className:String = arrClass[arrClass.length - 1];
			var functionName:String = stack.split("/")[1];
			if ( functionName == null )
			{
				functionName = className;
			}
			var arrLine:Array = arr[1].split(":");
			if (arrLine.length > 1) {
				var line:String = arrLine[arrLine.length-1].split("]")[0]
				trace( "[" + className + "][" + functionName + "]" + "[" + line + "]", tr );;
			} else {
				trace( "[" + className + "][" + functionName + "]", tr );
			}
		}
	}
}